var itemGridManager = null, pstyp = " ", fillinDate = "", bsart = "";
$(function () {
    initializeCommonUI();
    bindEvent();
    initItemGrid();
});

function initializeCommonUI() {
    bsart = $("#bsart").val();
    if ("ZFW" == bsart) {
        pstyp = "D";
    } else {
        pstyp = "";
    }
}

function bindEvent() {
    fillinDate = $("#fillinDate").val();
}

function initItemGrid() {
    var toolbar = UICtrl.getDefaultToolbarOptions({
        addHandler: function () {
            UICtrl.addGridRow(itemGridManager, {
                bnfpo: (itemGridManager.getData().length + 1) * 10,
                pstyp: pstyp,
                badat: fillinDate,
                erdat: fillinDate
            });
        },
        deleteHandler: function () {
            var _grid = UICtrl.getGridManager('#maingrid');
            DataUtil.delSelectedRows({
                action: 'sapPurchaseItem/deleteSapPurchaseItem.ajax',
                param: {},
                gridManager: _grid,
                idFieldName: 'id',
                onSuccess: function () {
                    reloadGrid();
                }
            });
        },
    })
    itemGridManager = UICtrl.grid('#maingrid', {
            columns: getGridColumns(),
            dataAction: 'server',
            url: web_app.name + '/sapPurchaseItem/querySapPurchaseItems.ajax',
            parms: {sapPurchaseId: getId()},
            height: '95%',
            heightDiff: -4,
            sortName: 'id',
            sortOrder: 'asc',
            checkbox: true,
            usePager: true,
            rownumbers: true,
            enabledEdit: true,
            fixedCellHeight: true,
            selectRowButtonOnly: true,
            autoApplyNextEditor: false,
            toolbar: toolbar,
            onBeforeEdit: function (editParm) {
                // var c = editParm.column, data = editParm.record;
                // //非资产类消耗性采购申请类型当“科目分配类型”选择K后“物料编号”字段调整为非必须输入项；“成本中心”、“总账科目”字段调整为必须输入项。订单号不可编辑。
                // if ("ZNE2" == bsart && (data.knttp == "K"|| data.knttp == "F" ) && c.name === 'kostl') {
                //     return true;
                // }else {
                //     return false;
                // }
                // //仅适用于KNTTP=F时
                // if (("ZFW" == bsart || "ZNE2" == bsart) && data.knttp == "F" && c.name === 'aufnr') {
                //     return true;
                // }else {
                //     return false;
                // }
                // //仅适用于KNTTP=A时
                // if (data.knttp == 'A' && c.name === 'anln1') {
                //     return true;
                // }else {
                //     return false;
                // }
            },
            onAfterEdit: function (editParm) {
                // if (editParm.record.knttp === "K") {
                //     var colums = itemGridManager.columns;
                //     colums.forEach(colum => {
                //         if (colum.name == "matnr") {
                //             colum.editor.required = false;
                //             itemGridManager.columns = colums
                //         }
                //     })
                // }
            }
        }
    );
    UICtrl.setSearchAreaToggle(itemGridManager);
}

function getGridColumns() {
    var columns = [];
        columns.push({
            display: "申购项次号", name: "bnfpo", width: "80", align: "left", type: "string",
            editor: {type: 'spinner', min: 10, max: 200, mask: 'nnn'}
        },);
        columns.push({display: "项次类别", name: "pstyp", width: "100", align: "left", type: "string", hide: true},);
        columns.push({
            display: "科目分配类别", name: "knttp", width: "100", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "knttp",
                    getParam: function (item) {
                        return {filterValue: $("#bsart").val()}
                    },
                    back: {
                        knttp: "knttp"
                    }
                },
            }
        },);
        columns.push({
            display: "工厂", name: "werks", width: "100", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "WERKS"}
                    },
                    back: {
                        WERKS: "werks",
                        NAME1: "name1"
                    },

                },
            }
        },);
        columns.push({
            display: "工厂名称", name: "name1", width: "200", align: "left", type: "string",
            editor: {required: false, type: "text"}
        });
        columns.push({
            display: "库存地点", name: "lgort", width: "100", align: "left", type: "string",
            editor: {
                required: false, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "LGORT"}
                    },
                    back: {
                        LGORT: "lgort",
                        LGOBE: "lgobe"
                    }
                },
            }
        },);
        columns.push({
            display: "库存地点名称", name: "lgobe", width: "200", align: "left", type: "string",
            //editor: {required: false, type: "text"}
        },);
        columns.push({
            display: "短文本", name: "txz01", width: "200", align: "left", type: "string",
            editor: {required: true, type: "text"}
        },);
        columns.push({
            display: "物料组", name: "matkl", width: "100", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "MATKL"}
                    },
                    back: {
                        MATKL: "matkl"
                    }
                },
            }
        },);
        columns.push({
            display: "申购数量", name: "menge", width: 150, minWidth: 60, type: "string", align: "center",
            editor: {required: true, type: "text", mask: '9999999.999'}
        },);
        columns.push({
            display: "申购数量单位", name: "meins", width: 150, minWidth: 60, type: "string", align: "center",
            /*editor: {
                required: false, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {paramValue: "MEINS"}
                    },
                    back: {
                        MEINS: "meins"
                    }
                },
            }*/
            editor: {required: true, type: "text"}
        },);
        columns.push({
            display: "采购组", name: "ekgrp", width: 150, minWidth: 60, type: "string", align: "center",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "EKGRP"}
                    },
                    back: {
                        EKGRP: "ekgrp"
                    }
                },
            }
        },);
        columns.push({
            display: "批准日期", name: "frgdt", width: "100", align: "left", type: "string",
            //editor: {required: false, type: "date"}
        },);
        columns.push({
            display: "要求交货日期", name: "lfdat", width: "100", align: "left", type: "string",
            editor: {required: true, type: "date"}
        },);
        columns.push({display: "创建者", name: "ernam", width: "200", align: "left", type: "string"},);
        columns.push({
            display: "申请人", name: "afnam", width: "90", align: "left", type: "string",
            editor: {type: 'text', required: true},
        },);
        columns.push({
            display: "预估单价", name: "preis", width: "100", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99', required: true}
        },);
        columns.push({
            display: "价格基数", name: "ebanPeinh", width: "100", align: "left", type: "string",
            //editor: {type: 'text', mask: '9999999',required: false}
            render: function (item) {
                return item.ebanPeinh = 1;
            }
        },);
        columns.push({
            display: "币种", name: "waers", width: "100", align: "left", type: "string",
            editor: {
                required: true, type: "text",
                /*data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "WAERS"}
                    },
                    back: {
                        WAERS: "waers"
                    }
                },*/
            }
        },);
        columns.push({
            display: "评估金额", name: "ebanNetwr", width: "100", align: "left", type: "string",
            render: function (item) {
                if (item.ebanPeinh == '') {
                    return item.ebanNetwr = null;
                }
                return item.ebanNetwr = (item.preis * item.menge / item.ebanPeinh).toFixed(2);
            }
            //editor: {type: 'text'}
        },);
        columns.push({
            display: "会计分配序号", name: "zebkn", width: "100", align: "left", type: "string",
            editor: {type: 'text'},
            render: function (item) {
                //申购项次为消耗性采购时，从1开始步长为1自动编号，最大99
                //     if (item.knttp != ''){
                //         ZEBKN_NUM = ZEBKN_NUM + 1;
                //     }
                return item.zebkn = item.menge;
            }
        },);
        columns.push({
            display: "多重科目分配", name: "vrtkz", width: "100", align: "left", type: "string",
            //editor: {type: 'text'},
            render: function (item) {
                //资产消耗性申购，若申请数量大于1，此处不能为空，必须选择1
                if (item.knttp == "A" && item.menge > 1) {
                    return item.vrtkz = 1;
                }
            }
        },);
        columns.push({
            display: "部分发票", name: "twrkz", width: "100", align: "left", type: "string",
            editor: {type: 'text'},
            render: function (item) {
                //资产消耗性申购，若申请数量大于1，此处不能为空，必须选择1
                if (item.knttp == "A" && item.menge > 1) {
                    return item.twrkz = 1;
                }
            }
        },);
        columns.push({
            display: "PR分解数量", name: "ekbnMenge", width: "100", align: "left", type: "string",
            editor: {type: 'text'}
        },);
        columns.push({
            display: "总账科目", name: "sakto", width: "100", align: "left", type: "string",
            editor: {type: 'text', required: false}
        },);
        columns.push({
            display: "资产编号", name: "anln1", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {
                            fieldName: "ANLN1",
                            filterValue: '1000'
                        }
                    },
                    back: {
                        ANLN1: "anln1"
                    }
                },
            }
        },);
    return columns;
}

//获取数据保存的参数
function getExtendedData(processAction) {
    //回退、打回、转交时，不需要验证必填项是否已经填写；
    if (processAction == ProcessAction.BACK
        || processAction == ProcessAction.REPLENISH
        || processAction == ProcessAction.TRANSMIT) {
        //不验证
        $('#submitForm').attr('check', true);
    }
    var extendedData = {};
    var _grid = UICtrl.getGridManager('#maingrid');
    if (_grid) {
        var datas = DataUtil.getGridData({
            gridManager: _grid,
            isAllData: true
        });
        if (!datas) {
            return false;
        }
        extendedData.sapPurchaseItems = Public.encodeJSONURI(datas);
    }
    return extendedData;
}

function getId() {
    return $('#id').val();
}

function setId(value) {
    $("#id").val(value);
    var _grid = UICtrl.getGridManager('#maingrid');
    _grid.options.parms.sapPurchaseId = value;
}

function reloadGrid() {
    itemGridManager.loadData();
}

function getGridData() {
    var _grid = UICtrl.getGridManager('#maingrid');
    var datas = DataUtil.getGridData({
        gridManager: _grid,
        isAllData: true
    });
    return datas;
}
