package com.huigou.topsun.sap.exceptionReport.domain;

import com.huigou.data.domain.model.FlowBillAbstractEntity;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Auther: xin.lu
 * @Date: 2024/03/20/16:37
 * @Description: 品质异常报告
 */
@Data
@Entity
@Table(name = "sap_exception_report")
public class ExceptionReport extends FlowBillAbstractEntity {

    /**
     * 异常类型
     */
    @Column(name = "exception_type")
    private String exceptionType;

    /**
     * 呈报日期
     */
    @Column(name = "report_date")
    private Date reportDate;

    /**
     * 客户名称/供应商名称
     */
    @Column(name = "customer_name")
    private String customerName;

    /**
     * 客户单号
     */
    @Column(name = "customer_order_no")
    private String customerOrderNo;

    /**
     * 异常陈诉
     */
    @Column(name = "exception_state")
    private String exceptionState;

    /**
     * 异常原因
     */
    @Column(name = "exception_reason")
    private String exceptionReason;

    /**
     * 改善措施
     */
    @Column(name = "deal_method")
    private String dealMethod;

    /**
     * 责任部门
     */
    @Column(name = "duty_dept")
    private String dutyDept;

    /**
     * 责任部门名称
     */
    @Column(name = "duty_dept_name")
    private String dutyDeptName;

    /**
     * 校验员
     */
    @Column(name = "check_operator")
    private String checkOperator;

    /**
     * 校验员名称
     */
    @Column(name = "check_operator_name")
    private String checkOperatorName;

    /**
     * 处理结果
     */
    @Column(name = "deal_result")
    private String dealResult;

    /**
     * 单位主管
     */
    @Column(name = "manager")
    private String manager;

    /**
     * 副理
     */
    @Column(name = "deputy_manager")
    private String deputyManager;

    /**
     * 经理
     */
    @Column(name = "general_manager")
    private String generalManager;

    /**
     * 备注
     */
    @Column(name = "remark")
    private String remark;

    @Override
    protected String getCodeRuleId() {
        return "exceptionReport";
    }
}
